import processing.sound.*;
import java.io.FilenameFilter;

String[] filenames;
String fullPath = "/home/axel/Musique";
SoundFile toPlay;
int wichIsPlaying;
boolean isPaused;

void setup() {
  size(800, 800);
  filenames = loadFilenames(fullPath);

  for (int i = 0; i <  filenames.length; i++) {
    toPlay = new SoundFile(this, fullPath +"/" + filenames[i]);
  }
}

void draw() {
  background(38);
  int y = 0;
  for (int i = 0; i <  filenames.length; i++) {
    fill(255);
    rect(0, y, width, 100);
    fill(0);
    text(filenames[i].substring( 0, filenames[i].length()-4 ), 100, y+50);
    y+=100;
  }
  fill(255, 255, 255, 127);
  rect(0, height-100, width, 100);
  rect(width/2-25, height-57.25, 40, 40);
  rect(width/2+70, height-57.25, 40, 40);
  fill(0, 0, 0, 255);
  if (!isPaused) {
    rect(width/2-20, height - 50, 10, 25);
    rect(width/2, height - 50, 10, 25);
  } else {
    triangle(width/2-20, height-50, width/2-20, height-25, width/2+10, height - 37.5);
  }
  triangle(width/2-20-100, height-50, width/2-20-100, height-25, width/2-100, height - 37.5);
  triangle(width/2-20+100, height-50, width/2-20+100, height-25, width/2+100, height - 37.5);
  fill(0);
}
void mousePressed() { //rect(width/2+70, height-57.25, 40, 40);
  if (mouseX > width/2+70 && mouseX < width/2 +70 + 40 && mouseY > height-57.25 && mouseY < height-57.25 + 40) {
    wichIsPlaying++;
    if(wichIsPlaying < 0){
      wichIsPlaying = filenames.length;
    }
    else if(wichIsPlaying > filenames.length-1){
      wichIsPlaying = 0;
    }
      
    if (toPlay.isPlaying()) {
      toPlay.stop();
    }
    toPlay = new SoundFile(this, fullPath +"/" + filenames[wichIsPlaying]);
    toPlay.play();
  } else if (mouseX > width/2-25 && mouseX < width/2 - 25 + 40 && mouseY > height-57.25 && mouseY < height-57.25 + 40) {
    if (toPlay.isPlaying()) {
      toPlay.pause();
      isPaused = true;
    } else {
      toPlay.play();
      isPaused = false;
    }
  } else {
    for (int i = 0; i <  filenames.length; i++) {
      if (mouseY > i * 100 && mouseY < i * 100 + 100) {
        if (toPlay.isPlaying()) {
          toPlay.stop();
        }
        toPlay = new SoundFile(this, fullPath +"/" + filenames[i]);
        toPlay.play();
        wichIsPlaying = i;
      }
    }
  }
}

void keyPressed() {
  println(key, int(keyCode));
  if (key == ' ') {
    if (toPlay.isPlaying()) {
      toPlay.pause();
      isPaused = true;
    } else {
      toPlay.play();
      isPaused = false;
    }
  }
}



String[] loadFilenames(String path) {
  File folder = new File(path);
  FilenameFilter filenameFilter = new FilenameFilter() {
    public boolean accept(File dir, String name) {
      return name.toLowerCase().endsWith(".mp3"); // change this to any extension you want
    }
  };
  return folder.list(filenameFilter);
}
